---
title: Empty states
description: Empty states or blank pages are commonly used as placeholders for first-use, empty data or error screens. Their aim is to engage users when there is no content to display and that is why their design is extremely important from the point of view of the user experience of your website or app.
---


## Default markup

Use the default empty state to engage users in the critical moments of their experience with your website or app. A good empty state screen should let users know what is happening and what they should do next as well as encourage them to take action.

{% capture code %}
{% include ui/empty.html %}
{% endcapture %}
{% include example.html code=code %}


## Empty state with illustration

Make your empty state screen more attractive and engaging by adding an illustration. Thanks to a more personalized design, you will improve your brand image and make your website or app more user friendly.

{% capture code %}
{% include ui/empty.html illustration=true %}
{% endcapture %}
{% include example.html code=code %}
